'+--------------------------------------------------------------------------+
'|                                                                          |
'|                                Gallery                                   |
'|                                                                          |
'|                            GDImage project                               |
'|                                                                          |
'|                    Java Script like image selection.                     |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2009                             |
'|                           www.zapsolution.com                            |
'|                        pterrier@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 08-09-2009 (MM-DD-YYYY)            |
'|                        Last revised : 08-09-2009 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#IF 0
The purpose of this GDImage control:

It has been modeled on the Java Script i am using in my new website in the "Showroom" section.

When the program starts, it builds on the fly an icon for each of the picture found in the "Background" subfolder.
While processing the icons there is a small rotating "wait-spinner" to inform the user he must wait a little.

To select a new background, clic on the auto-hide "image-band".
To move the band to the left or to the right, move the cursor hover the arrow shown on the side,
if you clic on an arrow icon, then you jump directly to the end or to the begining of the band.

You can add or remove pictures to the "Background" folder to customize its content.

Note: Because the selected image is to be used as the window background, it is better to use only pictures with landscape orientation.

#ENDIF

#COMPILE EXE "Gallery.exe"
#OPTION VERSION5

'#OPTIMIZE SIZE
'#OPTIMIZE SPEED

#RESOURCE "Gallery.pbr"

'// Return the SKIN Author's name
DECLARE FUNCTION SK_AUTHOR() AS STRING
'// Return SKIN color set
DECLARE FUNCTION SK_ACTIVECAPTION() AS LONG       '// COLOR ACTIVE CAPTION
DECLARE FUNCTION SK_INACTIVECAPTION() AS LONG     '// COLOR INACTIVE CAPTION
DECLARE FUNCTION SK_TEXTCOLOR() AS LONG           '// COLOR TEXT
DECLARE FUNCTION SK_BTNTEXTCOLOR() AS LONG        '// COLOR BUTTON TEXT
DECLARE FUNCTION SK_POPMENUTEXT() AS LONG         '// COLOR POPUP MENU TEXT
DECLARE FUNCTION SK_POPMENUHILITE() AS LONG       '// COLOR POPUP MENU HILIGHTED TEXT
DECLARE FUNCTION SK_ACTIVEMENUBAR() AS LONG       '// COLOR MENU BAR HILIGHTED ITEM
DECLARE FUNCTION SK_INACTIVEMENUBAR() AS LONG     '// COLOR MENU BAR DEFAULT COLOR
DECLARE FUNCTION SK_CAPTIONFONT() AS STRING       '// CAPTION FONT TO USE
DECLARE FUNCTION SK_CAPTIONFONTHEIGHT() AS LONG   '// CAPTION FONT SIZE
DECLARE FUNCTION SK_PUSHBUTFONTSIZE() AS LONG     '// PUSH BUTTON FONT SIZE
DECLARE FUNCTION SK_TRACKHICOLOR() AS LONG        '// TRACK BAR HIGHLIGHTED VALUE
DECLARE FUNCTION SK_TEXTFONT() AS STRING          '// TEXT FONT TO USE
DECLARE FUNCTION SK_AEROEMULATE() AS LONG         '// CHECK IF AERO EMULATION IS ON
DECLARE FUNCTION SK_AEROBLURLEVEL() AS LONG       '// AERO BLURING LEVEL
DECLARE FUNCTION SK_AEROCOLOR() AS LONG           '// AERO GLASS COLOR
DECLARE FUNCTION SK_AEROTIMERDELAY() AS LONG      '// AERO TIMER REFRESH DELAY
DECLARE FUNCTION SK_COLORLABEL() AS STRING        '// GDIPLUS COLOR LIST FOR COLORPICKER COMBO
DECLARE FUNCTION SK_PROGRESSCOLOR() AS LONG       '// TRACK BAR PROGRESS COLOR
DECLARE FUNCTION SK_CENTERFORM() AS STRING        '// DEFAULT FORM BACKGROUND IMAGE

#INCLUDE "ZSKIN.INC"

#INCLUDE "GDIMAGE.INC"

DECLARE FUNCTION zTrace LIB "zTrace.DLL" ALIAS "zTrace" (zMessage AS ASCIIZ) AS LONG
'DECLARE FUNCTION zDebug LIB "zTrace.DLL" ALIAS "zDebug" (zMessage AS ASCIIZ) AS LONG

%VK_PRIOR                 = &H21
%VK_NEXT                  = &H22
%VK_END                   = &H23
%VK_HOME                  = &H24
%VK_LEFT                  = &H25
%VK_NUMPAD4               = &H64
%VK_UP                    = &H26
%VK_NUMPAD8               = &H68
%VK_RIGHT                 = &H27
%VK_NUMPAD6               = &H66
%VK_DOWN                  = &H28
%VK_NUMPAD2               = &H62

%SQUARE_MODE              = 2 ' 2 Texture stretching mode

'------------------------------------------------------------------------------------------
' LOCAL section
'------------------------------------------------------------------------------------------
%XMIN_SIZE              = 800 '// Window minimum width
%YMIN_SIZE              = 600 '// Window minimum height

%TIMER_DELAY            = 40  '// Timer delay (animation speed)
%ALPHA_MIN              = 85
%ALPHA_STEP             = 15

%ID_BACKGROUND          = -999
%ID_LEFT_ARROW          = -2
%ID_RIGHT_ARROW         = -3
%ID_SPINNER             = -4
%ID_LOGO                = -5
%ID_RECT                = -6

%IDC_CTRL               = -1
%IDC_STATIC             = -12
%IDC_BACK_LIST          = -36

%IDC_BTN_ABOUT          = -37
%IDC_BTN_HELP           = -46
%IDC_GEM                = -61

GLOBAL gnCtrl, gMainWnd AS DWORD
GLOBAL gnFocusID AS LONG, gsWasLabelName AS STRING

FUNCTION GetStaticValue(BYVAL sUseString AS STRING) AS LONG
    LOCAL nValue, nStaticHandle, nIndex AS LONG
    sUseString += "|"
    nStaticHandle = zGetMainItem(%IDC_STATIC)
    IF nStaticHandle THEN
       nIndex = SendMessage(nStaticHandle, 399, -1, STRPTR(sUseString))
       IF nIndex > -1 THEN '// We found it
          nValue = SendMessage(nStaticHandle, 409, nIndex, 0)
       END IF
    END IF
    FUNCTION = nValue
END FUNCTION

SUB SetStaticValue(BYVAL sUseString AS STRING, BYVAL nValue AS LONG)
    LOCAL nStaticHandle, nIndex AS LONG
    sUseString += "|"
    nStaticHandle = zGetMainItem(%IDC_STATIC)
    IF nStaticHandle = 0 THEN
       nStaticHandle = CreateWindowEx(0, "LISTBOX", "", %WS_CHILD OR %LBS_HASSTRINGS, 0, 0, 0, 0, zMainWindow(0), %IDC_STATIC, zsInstance(), BYVAL %NULL)
    END IF
    IF nStaticHandle THEN
       nIndex = SendMessage(nStaticHandle, 399, -1, STRPTR(sUseString))
       IF nIndex > -1 THEN '// We found same static
          CALL SendMessage(nStaticHandle, 410, nIndex, nValue)
       ELSE '// Add it to our static list
          CALL SendMessage(nStaticHandle, 410, SendMessage(nStaticHandle, 384, 0, STRPTR(sUseString)), nValue)
       END IF
    END IF
END SUB

SUB ListDeleteAll(BYVAL hList AS LONG)
    IF hList THEN CALL SendMessage(hList, %LB_RESETCONTENT, 0, 0)
END SUB

'SUB ListDelete(BYVAL hList AS LONG, BYVAL nIndex AS LONG)
'    IF nIndex > 0 THEN DECR nIndex '// Because ListBox is zero based
'    IF hList THEN CALL SendMessage(hList, %LB_DELETESTRING, nIndex, 0)
'END SUB

SUB ListSelectPlus(BYVAL hList AS LONG, BYVAL nSelected AS LONG)
    IF nSelected > 0 THEN DECR nSelected '// Because ListBox is zero based
    IF hList THEN CALL SendMessage(hList, %LB_SETCURSEL, nSelected, 0)
END SUB

FUNCTION ListFindString(BYVAL hList AS LONG, zTmp AS ASCIIZ) AS LONG
    LOCAL nIndex AS LONG
    nIndex = SendMessage(hList, %LB_FINDSTRING, -1, VARPTR(zTmp))
    IF nIndex > -1 THEN INCR nIndex: FUNCTION = nIndex
END FUNCTION

FUNCTION ListCount(BYVAL hList AS LONG) AS LONG
    IF hList THEN FUNCTION = SendMessage(hList, %LB_GETCOUNT, 0, 0)
END FUNCTION

FUNCTION ListGetCursel(BYVAL hList AS LONG) AS LONG
    LOCAL nSelected AS LONG
    IF hList THEN
       nSelected = SendMessage(hList, %LB_GETCURSEL, 0, 0)
       IF nSelected > -1 THEN INCR nSelected '// Because ListBox is zero based
    END IF
    FUNCTION = nSelected
END FUNCTION

FUNCTION ListAdd(BYVAL hList AS LONG, zTmp AS ASCIIZ) AS LONG
    IF hList THEN
       IF LEN(zTmp) THEN FUNCTION = SendMessage(hList, %LB_ADDSTRING, 0, VARPTR(zTmp))
    END IF
END FUNCTION

FUNCTION ListGetText(BYVAL hList AS LONG, BYVAL Item AS LONG) AS STRING
    LOCAL sItem AS STRING, nLEN AS LONG
    IF Item > 0 THEN
       DECR Item
       nLEN = SendMessage(hList, %LB_GETTEXTLEN, Item, 0)
       sItem = SPACE$(nLEN)
       CALL SendMessage(hList, %LB_GETTEXT, Item, BYVAL STRPTR(sItem))
       FUNCTION = sItem
    END IF
END FUNCTION

'// This is the place where we create all the sprites being used into the GDImage control
SUB GDImageCreateSprite()
    LOCAL lpr AS RECT
    LOCAL K, nBitmap, nX, nY, nW, nH, nSizeX, nSizeY, hList, nCountMax AS LONG
    LOCAL sFileName AS STRING

    CALL GetClientRect(gnCtrl, lpr)

'   // The contact icon background
    nBitmap = ZI_CreateBitmapFromFile(SK_FOLDER() + "Contact.png", nW, nH)
    ZD_DrawBitmapToCtrl(gnCtrl, 0, 0, nBitmap, ZD_ColorARGB(255, 0), %ID_RECT, %ZS_HIDDEN)
    ZD_SetObjectLocked(%ID_RECT, %TRUE)

'   // Create the "waiting" animated spinner sprite.
    nBitmap = ZI_CreateBitmapFromFile(SK_FOLDER() + "White_Spinner.png", nW, nH)
    CALL ZD_DrawBitmapToCtrl(gnCtrl, (lpr.nRight - nH) \ 2, (lpr.nBottom - nH) \ 2 - 20, nBitmap, ZD_ColorARGB(225, 0), %ID_SPINNER, %ZS_VISIBLE)
    CALL ZD_SetObjectFrameCount(%ID_SPINNER, nW \ nH)
    CALL ZD_SetObjectFrameToUse(%ID_SPINNER, 1, %FALSE)
    CALL ZD_SetObjectAnchorMode(%ID_SPINNER, %ANCHOR_CENTER)

'   // Draw our watermark logo
    nBitmap = ZI_CreateBitmapFromFile(SK_FOLDER() + "Copyright.png", nW, nH)
    CALL ZD_DrawBitmapToCtrl(gnCtrl, lpr.nRight - nW - 18, lpr.nBottom - nH, nBitmap, ZD_ColorARGB(225, 0), %ID_LOGO, %ZS_VISIBLE)
    CALL ZD_SetObjectLocked(%ID_LOGO, %TRUE)
    CALL ZD_SetObjectAnchorMode(%ID_LOGO, %ANCHOR_BOTTOM_RIGHT)

    hList = zGetMainItem(%IDC_BACK_LIST)
    nCountMax = ListCount(hList)
    nSizeX = 128: nSizeY = 128: nX = 2: nY = 0
    FOR K = 1 TO nCountMax
        CALL RedrawSpinner()
        CALL ZI_UpdateWindow(gnCtrl, 0)
        sFileName = ListGetText(hList, K)
        nBitmap = ZI_FitBitmapFromFile((sFileName), nSizeX, nSizeY)
        ZD_DrawBitmapToCtrl(gnCtrl, nX, nY, nBitmap, ZD_ColorARGB(%ALPHA_MIN, 0), K, %ZS_HIDDEN)
        ZD_SetObjectLocked(K, %TRUE)
        sFileName = MCASE$(PATHNAME$(NAME, sFileName)): REPLACE "_" WITH " " IN sFileName
        CALL ZD_SetObjectImageLabel(K, (sFileName))

        '//IF K = gnFocusID THEN ZD_SetObjectAngle(K, 340, %FALSE)
        '//IF K = gnFocusID THEN ZD_SetObjectScale(K, 1.2)

        nX += nSizeX + 4
    NEXT

'   // Left navigation arrow
    nBitmap = ZI_CreateBitmapFromFile(SK_FOLDER() + "Left_arrow.png", nW, nH)
    nY += (nSizeY - nH) / 2
    CALL ZD_DrawBitmapToCtrl(gnCtrl, 0, nY, nBitmap, ZD_ColorARGB(255, 0), %ID_LEFT_ARROW, %ZS_HIDDEN)
    CALL ZD_SetObjectLocked(%ID_LEFT_ARROW, %TRUE)
    CALL ZD_SetObjectAnchorMode(%ID_LEFT_ARROW, %ANCHOR_LEFT)

'   // Right navigation arrow
    nBitmap = ZI_CreateBitmapFromFile(SK_FOLDER() + "Right_arrow.png", nW, nH)
    CALL ZD_DrawBitmapToCtrl(gnCtrl, lpr.nRight - nW, nY, nBitmap, ZD_ColorARGB(255, 0), %ID_RIGHT_ARROW, %ZS_HIDDEN)
    CALL ZD_SetObjectLocked(%ID_RIGHT_ARROW, %TRUE)
    CALL ZD_SetObjectAnchorMode(%ID_RIGHT_ARROW, %ANCHOR_RIGHT)

'   // Make sure that the composited background is still at the bottom of z-order
    CALL ZD_SetObjectZorder(%ID_BACKGROUND, %ZD_ORDER_BOTTOM)

'   // Show icons and navigation arrows
    CALL ZD_GetObjectXY(1, nX, nY): IF nX < 0 THEN CALL ZD_SetObjectVisibility(%ID_LEFT_ARROW, %TRUE)
    CALL ZD_GetObjectXY(nCountmax, nX, nY): IF nX > lpr.nRight THEN CALL ZD_SetObjectVisibility(%ID_RIGHT_ARROW, %TRUE)
        CALL ZD_SetObjectVisibility(%ID_RECT, %TRUE)
    FOR K = 1 TO nCountmax
        CALL ZD_SetObjectVisibility(K, %TRUE)
    NEXT
'   // Hide the spinner
    CALL ZD_SetObjectVisibility(%ID_SPINNER, %FALSE)

'   // Update the display
    CALL ZI_UpdateWindow(gnCtrl, 0)

    CALL ZD_GetObjectXY(%ID_RECT, nX, nY): IF nY > -1 THEN CALL MoveIconUpDown(-1)
END SUB

'// Main entry point
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WndClassEx
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
'
    LOCAL hWinXP_Lib           AS LONG ' Handle to WinXP Theme DLL
    LOCAL hWinXP_IsThemeActive AS LONG ' Handle to WinXP's IsThemeActive function
    LOCAL IsInitialized        AS LONG
    LOCAL hGDIplus             AS LONG ' GDIPLUS

    zClass = "ZIMAGE3D"
'
    hMutex = CreateMutex(BYVAL %Null, 0, zClass)
    IF hMutex THEN
       IF GetLastError = %ERROR_ALREADY_EXISTS THEN
          DO
             hFound = FindWindow(zClass, ""): IF hFound THEN EXIT DO
             WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): WEND
          LOOP
          IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
          CALL SetForeGroundWindow(hFound)
          FUNCTION = 0
          EXIT FUNCTION
       END IF
    END IF

    CALL zSplitN(zExeName(), "", MyTitle$)
    MyTitle$ = PARSE$(MyTitle$, ".", 1)
'   // Check first for a valid OS version (at least XP)
    IF zOsVersion < 501 THEN
       MsgBox zSysErrorMessage(197),,MyTitle$
       EXIT FUNCTION
    END IF

    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(zsInstance(), zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = %EXTEND_EXTRA * 4
       wc.hInstance     = zsInstance()
       wc.hIcon         = LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN

     '************************************************************************************
     ' Load the GDImage.dll
       IF RegisterGDImageClass() = 0 THEN
          FUNCTION = 99:  EXIT FUNCTION ' If it fails to register then return ERROR = 99
       END IF
     '************************************************************************************

       CALL InitCommonControls
'
'      // Init GDIPLUS
       hGDIplus = zGdipStart()

     ' Window Extended Style
       dwExStyle = 0 ' %WS_EX_LAYERED '// Let the OS take care of the region for us (Doesn't work on XP)
     ' Windows Style, avoid using %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN with the Skin Engine
       dwStyle = %WS_POPUP ' OR %WS_CLIPCHILDREN OR %WS_CLIPSIBLINGS
'
       CALL SetRect(rc, 0, 0, %XMIN_SIZE, %YMIN_SIZE)
'      // Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
'      // but it won't hurt anything to keep it, in case we change our mind ;)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       gMainWnd = CreateWindowEx(dwExStyle, _         ' Extended Style For The Window
                              zClass, _               ' Class Name
                              (MyTitle$), _           ' Window Title
                              dwStyle, _              ' Defined Window Style
                              x, y, _                 ' Window Position
                              rc.nRight - rc.nLeft, _ ' Calculate Window Width
                              rc.nBottom - rc.nTop, _ ' Calculate Window Height
                              %NULL, _                ' No Parent Window
                              %NULL, _                ' No Menu
                              wc.hInstance, _         ' Instance
                              BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
'
       IF gMainWnd THEN


          IF (dwExStyle AND %WS_EX_LAYERED) THEN '// Warning this doesn't work on XP (only on VISTA and Windows 7)
             CALL SetLayeredWindowAttributes(gMainWnd, RGB(255,0,255), 255, %LWA_ALPHA OR %LWA_COLORKEY)
          END IF

'         // Load SKIN components and create SYS buttons
          CALL zInitSkin(gMainWnd, zsExePath() + "GallerySkin.zsk")

'         // Add the child controls being used by the application
          CALL AddChildControls()
'         // Add tooltip support to show the name hover the icons.
          CALL ZI_CreateToolTip(gnCtrl, "")

          CALL GDImageEnableEvents(gnCtrl)
          CALL GDImageBackground()

'         // *************************************************
'         // Show main window
'         // Create region and paint controls to double buffer
'         // *************************************************
          CALL zShowMainWindow(0)

'         // This is the place where we create all the sprites being used into the GDImage control.
'         // we load them after the main window has been shown, to display the "spinner wait" animation.
          CALL GDImageCreateSprite()

          CALL SetTimer(gMainWnd, 1, %TIMER_DELAY, %NULL)

          WHILE GetMessage(Msg, %NULL, 0, 0)  ' SK_MILLISECOND
             IF IsDialogMessage(gMainWnd, Msg) = %FALSE THEN
                CALL TranslateMessage(Msg)
                CALL DispatchMessage(Msg)
             END IF
          WEND

          CALL KillTimer(gMainWnd, 1)

          FUNCTION = msg.wParam

          END IF

'      // UNLOAD GDIPLUS
       CALL zGdipEnd(hGDIplus)

    END IF
'
    IF hMutex THEN CALL CloseHandle(hMutex)
'
END FUNCTION

'// Fill the background listbox
'// Warning: Currently only JPG files!
SUB DetectBackground()
    LOCAL hList, WashFind, hFind AS LONG
    LOCAL fd AS WIN32_FIND_DATA
    LOCAL zTmp AS ASCIIZ * %MAX_PATH
    LOCAL zBackground AS ASCIIZ * %MAX_PATH
    LOCAL sBackgroundPath AS STRING
    LOCAL nActiveBackgroundSize AS QUAD
    LOCAL nItemSize AS QUAD

'   // Size of the current active background image
    nActiveBackgroundSize = zsFileSize((SK_CENTERFORM()))

    sBackgroundPath = zsExePath() + "Background\"

    hList = zGetMainItem(%IDC_BACK_LIST)
    CALL ListDeleteAll(hList)

    WashFind = MyFindFirstFile((sBackgroundPath + "*.*"), fd)
    hFind = WashFind
    DO WHILE hFind > 0
       IF ASC(fd.cFileName) <> 46 THEN
          IF INSTR(CHR$(0,1,32,33,128), CHR$(fd.dwFileAttributes)) THEN
             zTmp = sBackgroundPath + fd.cFileName: CALL CharLower(zTmp)
             IF INSTR(".gif.bmp.png.jpg.", RIGHT$(zTmp, 4) + ".") THEN
                nItemSize = MAK(QUAD, fd.nFileSizeLow, fd.nFileSizeHigh)
                IF ListAdd(hList, zTmp) > -1 THEN
'                  // If same size, then we assume it is our current background...
                   IF nItemSize = nActiveBackgroundSize THEN zBackground = zTmp
                END IF
             END IF
          END IF
       END IF
       hFind = FindNextFile(WashFind, fd)
    LOOP
    CALL FindClose(WashFind)

    gnFocusID = ListFindString(hList, zBackground)
    CALL ListSelectPlus(hList, gnFocusID)

END SUB

'// Add child controls to main window
SUB AddChildControls()

    LOCAL hCtrl AS LONG
    LOCAL sImageName AS STRING
    LOCAL zClass AS ASCIIZ * 16
    LOCAL imgW, imgH AS LONG, rw AS RECT

'   Use the same font for both Aero and Standard mode
    CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

'   OpenGL section
'   Create the Visual graphic control
    zClass =  $GDImageClassName ' $GLImageClassName
    Style& = %WS_CHILD OR %WS_VISIBLE 'OR %WS_HSCROLL OR %WS_VSCROLL
    StyleEx& = 0 ' %WS_EX_STATICEDGE
    gnCtrl = CreateWindowEx(StyleEx&, _
                           zClass, _                  ' GDImage class name
                           "", _                      ' Optional full path name to picture
                           Style&, _                  ' window style
                           4, _                       ' initial x position
                           40, _                      ' initial y position
                           %XMIN_SIZE - (4 * 2), _    ' Calculate Window Width
                           %YMIN_SIZE - (40 + 4), _   ' Calculate Window Height
                           gMainWnd, _                ' parent window handle
                           %IDC_CTRL, _                ' ControlID
                           zsInstance(), _            ' program instance handle
                           BYVAL 0)                   ' creation parameters
'   Anchor the control to match the size of the parent window
    CALL zSetAnchorMode(gnCtrl, %ANCHOR_HEIGHT_WIDTH)


'   // Change default LED's anchor mode from top right to top center
    CALL zSetAnchorMode(GetDlgItem(gMainWnd, %ID_LED), %ANCHOR_RIGHT)
    CALL zSetZorder(GetDlgItem(gMainWnd, %ID_LED), %HWND_TOP)

    hCtrl = CreateWindowEx(0, "LISTBOX", "", %WS_CHILD OR %LBS_SORT, 0, 0, 0, 0, gMainWnd, %IDC_BACK_LIST, zsInstance(), BYVAL %NULL)
    CALL DetectBackground()

    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "BTN_Help.png"), zCXSYSICON(0,0), zCYSYSICON(0,0), %IDC_BTN_HELP, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Copyright (c) " + RIGHT$(DATE$, 4) + " Patrice Terrier")

    'hCtrl = zPushButton(gMainWnd, (SK_FOLDER() + "BTN_About.png"), "", %XMIN_SIZE - (90 + 4), %YMIN_SIZE - 18, 90, 16, %IDC_BTN_ABOUT, SK_BTNTEXTCOLOR(), -1, 0)
    'CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    'CALL zSetZorder(hCtrl, %HWND_BOTTOM)
    'CALL zCreateToolTip(hCtrl, "Copyright (c) " + RIGHT$(DATE$, 4) + " Patrice Terrier")

    sImageName = SK_FOLDER() + "Gem.png"
    CALL ZI_GetImageSizeFromFile((sImageName), imgW, imgH)
    CALL GetWindowRect(gMainWnd, rw)
    hCtrl = zFrameButton(gMainWnd, (sImageName), "", ((rw.nRight - rw.nLeft) - imgW) \ 2, 0, imgW, imgH, %IDC_GEM, 0)
    '//CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_WIDTH)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)

END SUB

SUB GdimageResize()
    CALL GDImageBackground()
END SUB

SUB ResizeWindow(BYVAL hWnd AS LONG, BYVAL ChangeBackground AS LONG)
'CALL KillTimer(hWnd, 1)
    IF zComposited() THEN lRes& = zBeginDeferWindowPos(hWnd, 0)
    CALL zDrawBackground()
    CALL EnumChildWindows(hWnd, CODEPTR(AnchorEnum), lRes&)
    IF zComposited() THEN CALL zEndDeferWindowPos(hWnd, lRes&)

    IF ChangeBackground THEN
       CALL GDImageBackground()
       CALL zUpdateWindow(hWnd, 0)
    END IF
'CALL SetTimer(hWnd, 1, 30, %NULL)
END SUB

SUB UpdateListBox(sUseFile AS STRING)
    LOCAL hList, WashFind, hFind, ImageCount, DoIt, Img AS LONG
    LOCAL fd AS WIN32_FIND_DATA
    LOCAL zTmp AS ASCIIZ * %MAX_PATH
    LOCAL sPath AS STRING

    hList = zGetMainItem(%IDC_BACK_LIST)
    CALL ListDeleteAll(hList)

    sUseFile = zCharLower((sUseFile))
    CALL zSplitN(sUseFile, sPath, "")

    WashFind = MyFindFirstFile((sPath + "*.*"), fd)
    hFind = WashFind
    DO WHILE hFind > 0

       IF ASC(fd.cFileName) <> 46 THEN
          IF INSTR(CHR$(0,1,32,33,128), CHR$(fd.dwFileAttributes)) THEN
             zTmp = sPath + fd.cFileName: CALL CharLower(zTmp)
             DoIt = %FALSE
             IF RIGHT$(zTmp, 4) = ".jpg"  THEN DoIt = %TRUE: GOTO CheckDone
             IF RIGHT$(zTmp, 4) = ".png"  THEN DoIt = %TRUE: GOTO CheckDone
             IF RIGHT$(zTmp, 4) = ".bmp"  THEN DoIt = %TRUE: GOTO CheckDone
             IF RIGHT$(zTmp, 4) = ".gif"  THEN DoIt = %TRUE: GOTO CheckDone
             IF RIGHT$(zTmp, 4) = ".tif"  THEN DoIt = %TRUE: GOTO CheckDone
             IF RIGHT$(zTmp, 5) = ".jpeg" THEN DoIt = %TRUE: GOTO CheckDone
             IF RIGHT$(zTmp, 5) = ".tiff" THEN DoIt = %TRUE
CheckDone:
             IF DoIt THEN
                IF ListAdd(hList, zTmp) > -1 THEN
                   INCR ImageCount
                END IF
             END IF
          END IF
       END IF
       hFind = FindNextFile(WashFind, fd)

    LOOP
    CALL FindClose(WashFind)

    ListSelectPlus(hList, ListFindString(hList, (sUseFile)))

    Img = zCreateImageFromFile((sUseFile))
    IF Img THEN
       CALL zDisposeImage(zGetProperty(gMainWnd, %FORM_Center))
       CALL zsCopyFile((sUseFile), (SK_CENTERFORM()))
       CALL zSetProperty(gMainWnd, %FORM_Center, Img)
       CALL ResizeWindow(gMainWnd, 1)
    END IF

END SUB

'// This is the magic place to control what is going on inside of the GDImage graphic container!
FUNCTION GDImageCallBack(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL lpr AS RECT
    LOCAL nHoverID, nRet, nObjectID, nX, nY, x1, y1, ObjectType AS LONG
    LOCAL sLabelName AS STRING

    nRet = %FALSE ' Do not stop the event processing in GDImage

    nObjectID = ZI_MouseOverObjectID()

    SELECT CASE LONG Msg

    CASE %WM_LBUTTONDOWN
         IF nObjectID THEN
            IF nObjectID > 0 THEN

               '//nSelected is int = ZD_GetObjectSelected(nObjectID)
               ObjectType = ZD_GetObjectType(nObjectID)
               IF (ObjectType = %OBJECT_BITMAP) OR (ObjectType = %OBJECT_TEXTBITMAP) THEN
                  IF gnFocusID <> nObjectID THEN
                     CALL ListSelectPlus(zGetMainItem(%IDC_BACK_LIST), nObjectID)
                     CALL ZD_SetObjectAlpha(%ID_LOGO, 255, %FALSE)
                     CALL GDImageUpdateBackground()
                     gnFocusID = nObjectID
'//                     CALL GDImageChangeFocus(nObjectID)
                  END IF
               END IF
            ELSE
               IF nObjectID = %ID_LEFT_ARROW THEN
                  IF GetStaticValue("nMoving") = 0 THEN
                     CALL MoveIconToTheRight()
                  END IF
               ELSEIF nObjectID = %ID_RIGHT_ARROW THEN
                  IF GetStaticValue("nMoving") = 0 THEN
                     CALL MoveIconToTheLeft()
                  END IF
               END IF
            END IF
         END IF

    CASE %WM_LBUTTONUP
         IF nObjectID > 0 THEN
'            CALL UpdateQualityStatus(%TRUE)
         END IF

    CASE %WM_RBUTTONDOWN
         IF nObjectID THEN
            IF nObjectID > 0 THEN

'              hDW = ZI_CreateDW(gMainWnd)
'              sDataString = ZI_LoadDialog(gMainWnd)
'              CALL ZI_DestroyDW(hDW)
'              IF LEN(sDataString) THEN
'                 CALL UpdateListBox(sDataString)
'              END IF

            END IF
         END IF

    CASE %WM_MOUSEMOVE
         nHoverID = GetStaticValue("nHoverID")
         IF nObjectID > 0 THEN
            IF nHoverID <> nObjectID THEN
               CALL SetStaticValue("nHoverID", nObjectID)

               '// Tooltip hover image
               sLabelName = ZD_GetObjectImageLabel(nObjectID)
               '// Tooltip hover image
               IF sLabelName <> gsWasLabelName THEN
                  CALL ZI_SetToolTipText(gnCtrl, (sLabelName))
               END IF
               gsWasLabelName = sLabelName

            END IF
         ELSE

            gsWasLabelName = "": CALL ZI_SetToolTipText(gnCtrl, (gsWasLabelName))

            CALL SetStaticValue("nHoverID", 0)
            IF nObjectID = %ID_LEFT_ARROW THEN
               IF GetStaticValue("nHoverArrow") = 0 THEN
                  CALL SetStaticValue("nHoverArrow", -1)
                  CALL MoveIconLeftRight(1)
               END IF
            ELSEIF nObjectID = %ID_RIGHT_ARROW THEN
               IF GetStaticValue("nHoverArrow") = 0 THEN
                  CALL SetStaticValue("nHoverArrow", -1)
                  CALL MoveIconLeftRight(-1)
               END IF
            ELSE
               CALL ZD_GetObjectXY(%ID_RECT, nX, nY)
               IF HI(INTEGER, lParam) < 133 THEN
                  IF nY < 0 THEN MoveIconUpDown(1)
               ELSE
                  IF nY > -1 THEN CALL MoveIconUpDown(-1)
               END IF
            END IF
         END IF

    CASE %WM_KEYDOWN

    CASE %WM_SIZE
         CALL GDImageResize()

    CASE %WM_MOUSEWHEEL

    END SELECT

    FUNCTION = nRet
END FUNCTION

'// Main window procedure
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL ps AS PAINTSTRUCT
    LOCAL rc AS RECT, p AS POINTAPI
    LOCAL hDC, wP, nX, nY AS LONG
    LOCAL K, nCountMax, nW, nH, nSizeX, nSizeY AS LONG

    SELECT CASE LONG Msg

    CASE %WM_GETMINMAXINFO
         LOCAL pMM AS MINMAXINFO PTR
         pMM = lParam
         @pMM.ptMinTrackSize.x = zMinTrackSizeX(0)
         @pMM.ptMinTrackSize.y = zMinTrackSizeY(0)

    CASE %WM_COPYDATA

    CASE %WM_COMMAND
         wP = LO(INTEGER, wParam)
         IF wP = %ID_MAXIMIZE OR wP = %ID_RESTORE THEN
            GetClientRect(gnCtrl, rc)
            '// The contact icon background
            ZD_SetObjectXY(%ID_RECT, 0, 0, %FALSE)
            '// The icons
            nCountMax = ListCount(zGetMainItem(%IDC_BACK_LIST))
            nSizeX = 128: nSizeY = 128: nX = 2: nY = 0
            FOR K = 1 TO nCountMax
               ZD_SetObjectXY(K, nX, nY, %FALSE)
               nX += nSizeX + 4
            NEXT
            '// Left navigation arrow
            ZD_GetObjectBound(%ID_LEFT_ARROW, nW, nH)
            nX = 0: nY = (nSizeY - nH) / 2
            ZD_SetObjectXY(%ID_LEFT_ARROW, 0, nY, %FALSE)
            ZD_SetObjectVisibility(%ID_LEFT_ARROW, %FALSE)
            '// Right navigation arrow
            ZD_GetObjectBound(%ID_RIGHT_ARROW, nW, nH)
            nX = rc.nRight - nW
            ZD_SetObjectXY(%ID_RIGHT_ARROW, nX, nY, %FALSE)
            ZD_SetObjectVisibility(%ID_RIGHT_ARROW, %TRUE)
         END IF
         IF zButtonSysCommand(hWnd, wParam) THEN FUNCTION = 0: EXIT FUNCTION

         SELECT CASE LONG wP

         CASE %IDC_BTN_HELP, %IDC_BTN_ABOUT
              CALL ShellExecute(BYVAL %NULL, "open", "http://www.zapsolution.com", "", "", %SW_SHOW)
              FUNCTION = 0: EXIT FUNCTION

         END SELECT
         IF GetFocus <> hWnd THEN CALL SetFocus(hWnd)

    CASE %WM_SIZE
         CALL ResizeWindow(hWnd, 0)

    CASE %WM_SETTEXT
'        // Windows please do your job first.
         FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
'        // Update caption
         CALL zPaintBackground(0)
'        // Repaint only the caption.
         CALL GetClientRect(hWnd, rc)
         CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
         CALL InvalidateRect(hWnd, rc, 0)
         CALL UpdateWindow(hWnd)
         EXIT FUNCTION

    CASE %WM_NCLBUTTONDBLCLK
         IF IsIconic(hWnd) = 0 THEN
            LOCAL CaptionHeight AS LONG
            p.X = LO(INTEGER, lParam): p.Y = HI(INTEGER, lParam)
            CALL ScreenToClient(hWnd, p)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, CaptionHeight)
            IF p.Y < CaptionHeight THEN
               IF IsZoomed(hWnd) THEN
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_RESTORE, 0))
               ELSE
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_MAXIMIZE, 0))
               END IF
               FUNCTION = 0: EXIT FUNCTION
            END IF
         END IF

    CASE %WM_NCACTIVATE
         LOCAL hBut AS LONG
         hBut = GetDlgItem(hWnd, %ID_LED)
         IF hBut THEN
'           // Windows please do your job first.
            FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
            IF zMainWindow(0) = GetForegroundWindow THEN
               gColorCaption = SK_ACTIVECAPTION()
            ELSE
               gColorCaption = SK_INACTIVECAPTION()
            END IF
'           // Update caption
            CALL zPaintBackground(0)

'           // Repaint only the caption.
            CALL GetClientRect(hWnd, rc)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
            CALL InvalidateRect(hWnd, rc, 0)
            CALL UpdateWindow(hWnd)

            EXIT FUNCTION
         END IF

    CASE %WM_ERASEBKGND
         FUNCTION = 1: EXIT FUNCTION

    CASE %WM_PAINT
         BeginPaint(hWnd, ps)
         CALL zPaintDoubleBuffer(hWnd, ps.hDC)
         CALL EndPaint(hWnd, ps)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_DESTROY

'        // Remove all image resource from memory
'        // Must be done just before to exit the main program in case zAddResource
'        // has been used to store image handles that are not tied to a specific control.
'        // For example: Image used in an ownerdrawn menu.
         CALL zRemoveAllImageResource()

'        // Delete Image, Bitmap and DC matching this window
         CALL zDestroyWindowResource(hWnd)

         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_TIMER
         CALL RenderAnimation(hWnd)

    CASE %WM_NCHITTEST
         CALL ZD_GetObjectXY(%ID_RECT, nX, nY)
         IF nY > -1 THEN
         GetClientRect(gnCtrl, rc)
         IF rc.nRight > 1024 THEN K = 34 ELSE K = 33
         CALL MoveIconUpDown(-K)
      END IF

    END SELECT

    FUNCTION = zDefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

SUB GDImageEnableEvents(BYVAL hGDImageCtrl AS LONG)
    LOCAL lpCallBack AS DWORD
    lpCallBack = CODEPTR(GDImageCallBack)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_LBUTTONDOWN, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_LBUTTONUP, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_LBUTTONDBLCLK, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_RBUTTONDOWN, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_KEYDOWN, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_KEYUP, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_MOUSEMOVE, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_NCHITTEST, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_MOUSEWHEEL, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_SIZE, %TRUE)
END SUB

SUB GDImageBackground()
    LOCAL lp AS POINTAPI, rc, lpr AS RECT
    LOCAL hIC, hDC, graphics, nBackground, Img, ImgW, ImgH, xP, yP, xS, yS, bmW, bmH, CtrlW, CtrlH, bBitmapFound AS LONG

    CALL GetWindowRect(zGetMainItem(%IDC_CTRL), lpr)
    lp.x = lpr.nLeft: lp.y = lpr.nTop
    CALL ScreenToClient(gMainWnd, lp)

       CALL GetClientRect(gMainWnd, rc)
       CtrlW = lpr.nRight - lpr.nLeft
       CtrlH = lpr.nBottom - lpr.nTop
       nBackground = ZD_GetObjectBitmap(%ID_BACKGROUND)
       IF nBackground THEN
          bBitmapFound = -1
          CALL ZI_GetBitmapSize(nBackground, bmW, bmH)
          IF bmW < CtrlW OR bmH < CtrlH THEN bmW = 0: bmH = 0
       END IF
       IF bmW THEN
          hIC = zDisplayDC()
          hDC = CreateCompatibleDC(hIC)
          CALL SelectObject(hDC, nBackground)
          CALL DeleteDC(hIC)
       ELSE
          '// Use default 1400 x 900
          IF CtrlW > 1400 OR CtrlH > 900 THEN
             hDC = ZI_Create32bitDC(CtrlW, CtrlH, &HFF000000&)
          ELSE
             hDC = ZI_Create32bitDC(1400, 900, &HFF000000&)
          END IF
       END IF

       nBackground = ZI_GetBitmapFromDC(hDC)
       IF GdipCreateFromHDC(hDC, graphics) = 0 THEN
          CALL ZI_SetProperty(gnCtrl, %ZI_GradientTop, 0)
          CALL ZI_SetProperty(gnCtrl, %ZI_GradientBottom, 0)
          Img = zGetProperty(gMainWnd, %FORM_Center): CALL zGetImageSize(Img, ImgW, ImgH)
          CALL zComputeAspect(ImgW, ImgH, rc.nRight, rc.nBottom, xP, yP, xS, yS)
         '// Set up stretching QualityMode
          CALL GdipSetInterpolationMode(graphics, 2)
          CALL GdipDrawImageRectRectI(graphics, Img, xP - lp.x, yP - lp.y, xS, yS, 0, 0, ImgW, ImgH, %UnitPixel, 0)
          CALL ZD_DrawBitmapToCtrl(gnCtrl, 0, 0, nBackground, &HFFFFFFFF, %ID_BACKGROUND, %ZS_VISIBLE)
          CALL GdipDeleteGraphics(graphics)

          CALL ZD_SetObjectZorder(%ID_BACKGROUND, %ZD_ORDER_BOTTOM) '// Make sure the background is at the bottom of z-order
          CALL ZD_SetObjectLocked(%ID_BACKGROUND, %TRUE)

       END IF
       IF hDC THEN CALL DeleteDC(hDC)

END SUB

'// This is the callback being used for all the animations
SUB RenderAnimation(BYVAL hWnd AS LONG)', BYVAL hGLDC AS LONG, BYVAL hGLRC AS LONG)
    LOCAL K, nCountMax, nAlpha, nDone, nHoverID AS LONG

    nCountmax = ListCount(zGetMainItem(%IDC_BACK_LIST))
    nHoverID = GetStaticValue("nHoverID")

    FOR K = nCountmax TO 1 STEP -1
        nAlpha = ZD_GetObjectAlpha(K)
        IF nHoverID = K THEN
           IF nAlpha < 255 THEN
              nDone = -1
              nAlpha += %ALPHA_STEP
              IF nAlpha > 255 THEN nAlpha = 255
              CALL ZD_SetObjectAlpha(K, nAlpha, %FALSE)
           END IF
        ELSE
           IF nAlpha > %ALPHA_MIN THEN
              nDone = -1
              nAlpha -= %ALPHA_STEP
              IF nAlpha < %ALPHA_MIN THEN nAlpha = %ALPHA_MIN
              CALL ZD_SetObjectAlpha(K, nAlpha, %FALSE)
           END IF
        END IF
    NEXT

'   // Fade the copyright logo
    nAlpha = ZD_GetObjectAlpha(%ID_LOGO)
    IF nAlpha THEN
       nDone = -1
       nAlpha -= 2: IF nAlpha < 0 THEN nAlpha = 0
       CALL ZD_SetObjectAlpha(%ID_LOGO, nAlpha, %FALSE)
    END IF

    IF nDone THEN ZI_UpdateWindow(gnCtrl, 0)

END SUB

SUB RedrawSpinner()
    STATIC nStCount AS LONG
    nStCount += 1: IF nStCount > ZD_GetObjectFrameCount(%ID_SPINNER) THEN nStCount = 1
    CALL ZD_SetObjectFrameToUse(%ID_SPINNER, nStCount, %FALSE)
END SUB

SUB MoveIconLeftRight(BYVAL nLeftRight AS LONG)
    LOCAL lpr AS RECT
    LOCAL K, nS, nStepX, nX, nY, nDoIt, nUseStep, nCountMax, nArrowClic, nMoving AS LONG

    CALL GetClientRect(gnCtrl, lpr)
    nCountMax = ListCount(zGetMainItem(%IDC_BACK_LIST))

    nUseStep = 4
    IF lpr.nRight > 1024 THEN nUseStep = 8
    IF lpr.nRight > 1600 THEN nUseStep = 16
    nUseStep = nUseStep * nLeftRight

    IF nUseStep < 0 THEN  '// Right arrow
       CALL ZD_GetObjectXY(nCountmax, nX, nY): IF nX > lpr.nRight THEN nDoIt = -1
    ELSE          '// Left arrow
       CALL ZD_GetObjectXY(1, nX, nY): IF nX < 0 THEN nDoIt = -1
    END IF

    IF nDoIt THEN
       nStepX = ABS(nUseStep)
       nMoving = GetStaticValue("nMoving")
       IF nMoving = 0 THEN
          SetStaticValue("nMoving", 1)
          FOR nS = 1 TO 132 STEP nStepX
              FOR K = 1 TO nCountmax
                  ZD_GetObjectXY(K, nX, nY)
                  ZD_SetObjectXY(K, nX + nUseStep, nY, %FALSE)
'//IF nS = 1 THEN ZD_SetObjectAlpha(K, 128, False)
              NEXT
              ZD_GetObjectXY(1, nX, nY): IF nX < 0 THEN nDoIt = %TRUE ELSE nDoIt = %FALSE: nArrowClic = %ID_LEFT_ARROW
              ZD_SetObjectVisibility(%ID_LEFT_ARROW, nDoIt)
              ZD_GetObjectXY(nCountmax, nX, nY): IF nX > lpr.nRight THEN nDoIt = %TRUE ELSE nDoIt = %FALSE: nArrowClic = %ID_RIGHT_ARROW
              ZD_SetObjectVisibility(%ID_RIGHT_ARROW, nDoIt)
              IF nArrowClic = 0 THEN ZI_UpdateWindow(gnCtrl, 0)
          NEXT
          IF ZD_IsObjectVisible(%ID_RIGHT_ARROW) = 0 THEN
             ZD_GetObjectXY(nCountmax, nX, nY)
             IF nX + 132 > lpr.nRight THEN MoveIconToTheLeft()
          END IF
          IF ZD_IsObjectVisible(%ID_LEFT_ARROW) = 0 THEN
             ZD_GetObjectXY(1, nX, nY)
             IF nX > 0 THEN MoveIconToTheRight()
          END IF

          SetStaticValue("nHoverArrow", 0)
          SetStaticValue("nMoving", 0)
       END IF
    END IF

END SUB

SUB MoveIconUpDown(BYVAL nUpDown AS LONG)
    LOCAL lpr AS RECT
    LOCAL K, nS, nStepX, nX, nY, nDoIt, nUseStep, nMoving, nCountMax AS LONG

    nCountMax = ListCount(zGetMainItem(%IDC_BACK_LIST))
    CALL GetClientRect(gnCtrl, lpr)
    nUseStep = 4: IF lpr.nRight > 1024 THEN nUseStep = 8
    nUseStep = nUseStep * nUpDown
    nStepX = Abs(nUseStep)

    nMoving = GetStaticValue("nMoving")
    IF nMoving = 0 THEN
       SetStaticValue("nMoving", 1)
       FOR nS = 1 TO 132 STEP nStepX

           ZD_GetObjectXY(%ID_RECT, 0, nY)
           ZD_SetObjectXY(%ID_RECT, 0, nY + nUseStep, %FALSE)

           FOR K = 1 TO nCountmax
               ZD_GetObjectXY(K, nX, nY)
               ZD_SetObjectXY(K, nX, nY + nUseStep, %FALSE)
           NEXT
           ZD_GetObjectXY(1, nX, nY): IF nX < 0 THEN nDoIt = %TRUE ELSE nDoIt = %FALSE
           ZD_GetObjectXY(%ID_LEFT_ARROW, nX, nY)
           ZD_SetObjectXY(%ID_LEFT_ARROW, nX, nY + nUseStep, %FALSE)
           ZD_SetObjectVisibility(%ID_LEFT_ARROW, nDoIt)
           ZD_GetObjectXY(nCountmax, nX, nY): IF nX > lpr.nRight THEN nDoIt = %TRUE ELSE nDoIt = %FALSE
           ZD_GetObjectXY(%ID_RIGHT_ARROW, nX, nY)
           ZD_SetObjectXY(%ID_RIGHT_ARROW, nX, nY + nUseStep, %FALSE)
           ZD_SetObjectVisibility(%ID_RIGHT_ARROW, nDoIt)

           ZI_UpdateWindow(gnCtrl, 0)
       NEXT
       SetStaticValue("nMoving", 0)
    END IF

END SUB

SUB MoveIconToTheLeft()
    LOCAL lpr AS RECT
    LOCAL K, nX, nY, nUseX, nCountMax AS LONG
    GetClientRect(gnCtrl, lpr)
    nCountMax = ListCount(zGetMainItem(%IDC_BACK_LIST))
    ZD_GetObjectXY(1, nX, nY)

    nUseX = lpr.nRight + 1
    FOR K = nCountmax TO 1 STEP -1
       nUseX -= 132
       ZD_SetObjectXY(K, nUseX, nY, %FALSE)
    NEXT
'   // Shall we show the arrow icon?
    ZD_GetObjectXY(1, nX, nY): IF nX < 0 THEN nUseX = %TRUE ELSE nUseX = %FALSE
    ZD_SetObjectVisibility(%ID_LEFT_ARROW, nUseX)
    ZD_GetObjectXY(nCountmax, nX, nY): IF nX > lpr.nRight THEN nUseX = %TRUE ELSE nUseX = %FALSE
    ZD_SetObjectVisibility(%ID_RIGHT_ARROW, nUseX)

    ZI_UpdateWindow(gnCtrl, 0)
END SUB

SUB MoveIconToTheRight()
    LOCAL lpr AS RECT
    LOCAL K, nX, nY, nUseX, nCountMax AS LONG
    GetClientRect(gnCtrl, lpr)
    nCountMax = ListCount(zGetMainItem(%IDC_BACK_LIST))
    ZD_GetObjectXY(1, nX, nY)

    nUseX = 0
    FOR K = 1 TO nCountmax
        ZD_SetObjectXY(K, nUseX, nY, %FALSE)
        nUseX += 132
    NEXT
'   // Shall we show the arrow icon?
    ZD_GetObjectXY(1, nX, nY): IF nX < 0 THEN nUseX = %TRUE ELSE nUseX = %FALSE
    ZD_SetObjectVisibility(%ID_LEFT_ARROW, nUseX)
    ZD_GetObjectXY(nCountmax, nX, nY): IF nX > lpr.nRight THEN nUseX = %TRUE ELSE nUseX = %FALSE
    ZD_SetObjectVisibility(%ID_RIGHT_ARROW, nUseX)

    ZI_UpdateWindow(gnCtrl, 0)
END SUB

SUB GDImageUpdateBackground()
    LOCAL hList, Img AS LONG
    LOCAL sUseFile AS STRING

    hList = zGetMainItem(%IDC_BACK_LIST)
    sUseFile = ListGetText(hList, ListGetCursel(hList))
    Img = zCreateImageFromFile((sUseFile))
    IF Img THEN
       CALL zDisposeImage(zGetProperty(gMainWnd, %FORM_Center))
       CALL zsCopyFile((sUseFile), (SK_CENTERFORM()))
       CALL zSetProperty(gMainWnd, %FORM_Center, Img)
       CALL ResizeWindow(gMainWnd, 1)
    END IF

END SUB

